CON

  _clkmode = xtal1+pll16x
  _xinfreq = 5_000_000
  Buf_size = 4096
  
OBJ

  sd[2] :"fsrw_shared"
  text  :"tv_text"
  
VAR
  byte Header[44]             
  long SampleRate
  long NumOfChannels
  long BitsPerSample
  long NumOfSamples
  long Filesize
  long Buf1[Buf_size]
  long counter
Dat
  Encdata byte "johnjohn",0
  EncBit byte  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  Decdata byte " ",0

PUB main | ch, r1, r2, sta, bytes, encdataindex, encbitindex,decdataindex, index,x,y,char 

{----------------Activating TV--------------------}

  text.start(12)

{----------------clearing encbit------------------}
  repeat x from 0 to 31
    encbit[x]:=0
  text.out(13)
  text.str(string("encbit data deleted",13))


{---------Converting Data to be encoded-----------}
  encbitindex:=0
  encdataindex:=0
  x:=0
  text.bin(encdata[0],8)
  text.out(13)  
  repeat strsize(@encdata)
    char:=Byte[@encdata][encdataindex++]
    repeat x from 0 to 7
      encbit[encbitindex+x]:=(char>>(7-x))&%00000001
    encbitindex+=8
{---show encbit data}
  y:=0
  repeat x from 0 to strsize(@encdata)*8-1
    text.hex(encbit[x],2)
    text.out(" ")
    y:=x+1
    if (y//8==0)
      text.out(13)
   

{----------------Mounting SD card ----------------}

  sd[0].mount(0)

{-----------Reading Source file's Header----------}

  text.str(string("File sil.wav Info", 13))
  ReadHeader(string("sil.wav"))
                                           
{----------Copying header to target file----------}

  WriteHeader(string("silc.wav"))

{-----------Reading target file's Header----------}

  text.str(string("File silc.wav info",13))
  ReadHeader(string("silc.wav"))

{-Open source file for read and target for append-}

  r1:=sd[0].popen(string("sil.wav"),"r")
  GotoSampleData(string("sil.wav"))
  r2:=sd[1].popen(string("silc.wav"),"a")

{-Read Buf_size bytes to buf1 from source file and
  modify them before writing them to the target --}
    
  index:=0
  encbitindex:=0
  repeat 
    ch:=sd[0].pread(@Buf1,buf_size)
    if ch<0
      quit
    else
      repeat x from 1 to buf_size step 2
        if byte[@encbit][encbitindex]==$01
          if encbitindex==32
            next
          Byte[@Buf1][x]:=(Byte[@Buf1][x]&$fe)+$01
          encbitindex++
        else
          if encbitindex==32
            next 
          Byte[@Buf1][x]&=$fe
          encbitindex++
    sd[1].pwrite(@Buf1,ch)
  sd[0].pclose
  sd[1].pclose
  text.str(string("copied",13))

'---------clearing encbit----------
  repeat x from 0 to 31
    encbit[x]:=0
  text.out(13)
  text.str(string("encbit data deleted",13)) 
Pri ReadHeader(fname)|r 
  r:=sd[0].popen(fname,"r")                   
  if (r<>0)
    repeat
  r:=sd[0].pread(@Header, 44)                              'Read the header
  SampleRate:=Header[27]<<24+Header[26]<<16+Header[25]<<8+Header[24]
  text.str(string("Sample rate      : "))
  text.dec(SampleRate)
  text.out(13)
  text.out(" ")
  NumOfChannels:=Header[23]<<8+Header[22]
  text.str(string("# of channels    : "))
  text.dec(NumOfChannels)
  text.out(13)
  text.out(" ")
  BitsPerSample:=Header[35]<<8+Header[34]
  text.str(string("Bits per sample  : "))
  text.dec(BitsPerSample)
  text.out(13)
  text.out(" ")
  Filesize:=Header[43]<<24+Header[42]<<16+Header[41]<<8+Header[40]+44
  text.str(string("File size (bytes): "))
  text.dec(FileSize)
  text.out(13)
  text.out(" ")
  NumOfSamples:=(8*(Filesize-44))/(NumOfChannels*BitsPerSample)
  text.str(string("# of Samples     : "))
  text.dec(NumOfSamples)
  text.out(13)


Pri WriteHeader(fname)|sta,bytes,r
  r := sd[1].popen(fname, "w")
  sta := cnt
  bytes := 0
  sd[1].pwrite(@Header,44)

Pri GotoSampleData(fname)|r
  r:=sd[0].popen(fname,"r")
  repeat 44
    r:=sd[0].pgetc

Pri Gotoxy(x,y)
  text.out($0A)
  text.out(x)
  text.out($0B)
  text.out(y)

Pri Decode(size)|i, ddi, dbi
  dbi:=0
  repeat ddi from 0 to size-1
    DecData[ddi]:=encbit[dbi]<<7+encbit[dbi+1]<<6+encbit[dbi+2]<<5+encbit[dbi+3]<<4+encbit[dbi+4]<<3+encbit[dbi+5]<<2+encbit[dbi+6]<<1+encbit[dbi+7]
'    dbi+=7
  
PRI delay_ms(Duration)                                  
  waitcnt(((clkfreq / 1_000 * Duration - 3932)) + cnt)  